*** WeiDU-185/src/bcs.ml	Tue May 24 03:15:56 2005
--- WeiDU/src/bcs.ml	Mon Jun 23 10:13:10 2008
***************
*** 1,3 ****
--- 1,10 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.bcs.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
  open Util
  open Ids
  
***************
*** 106,123 ****
    | Load.IWD2,1 -> "GENERAL"
    | Load.IWD2,2 -> "RACE" 
    | Load.IWD2,3 -> "SUBRACE" 
!   | Load.IWD2,4 -> "CLASS" 
!   | Load.IWD2,5 -> "SPECIFIC" 
!   | Load.IWD2,6 -> "GENDER"
!   | Load.IWD2,7 -> "ALIGNMNT" 
! 
!   | Load.BG,0 -> "EA"
!   | Load.BG,1 -> "GENERAL"
!   | Load.BG,2 -> "RACE" 
!   | Load.BG,3 -> "CLASS" 
!   | Load.BG,4 -> "SPECIFIC"
!   | Load.BG,5 -> "GENDER" 
!   | Load.BG,6 -> "ALIGN" 
  
    | Load.PST,0 -> "EA"
    | Load.PST,1 -> "FACTION"
--- 113,148 ----
    | Load.IWD2,1 -> "GENERAL"
    | Load.IWD2,2 -> "RACE"
    | Load.IWD2,3 -> "SUBRACE"
!   | Load.IWD2,4 -> "SPECIFIC"
!   | Load.IWD2,5 -> "GENDER"
!   | Load.IWD2,6 -> "ALIGNMNT"
!   | Load.IWD2,7 -> "CLASS"
!   | Load.IWD2,8 -> "AVCLASS"
!   | Load.IWD2,9 -> "CLASSMSK"
! 
!   | Load.BG1,0 -> "EA"
!   | Load.BG1,1 -> "GENERAL"
!   | Load.BG1,2 -> "RACE"
!   | Load.BG1,3 -> "CLASS"
!   | Load.BG1,4 -> "SPECIFIC"
!   | Load.BG1,5 -> "GENDER"
!   | Load.BG1,6 -> "ALIGN"
! 
!   | Load.BG2,0 -> "EA"
!   | Load.BG2,1 -> "GENERAL"
!   | Load.BG2,2 -> "RACE"
!   | Load.BG2,3 -> "CLASS"
!   | Load.BG2,4 -> "SPECIFIC"
!   | Load.BG2,5 -> "GENDER"
!   | Load.BG2,6 -> "ALIGN"
! 
!   | Load.IWD1,0 -> "EA"
!   | Load.IWD1,1 -> "GENERAL"
!   | Load.IWD1,2 -> "RACE"
!   | Load.IWD1,3 -> "CLASS"
!   | Load.IWD1,4 -> "SPECIFIC"
!   | Load.IWD1,5 -> "GENDER"
!   | Load.IWD1,6 -> "ALIGN"
  
    | Load.PST,0 -> "EA"
    | Load.PST,1 -> "FACTION"
***************
*** 158,165 ****
    | Save_BCS_OC of out_channel
    | Save_BCS_Buffer of Buffer.t 
  
  let save_bcs game how bcs =
!   Stats.time "marsmahl BCS" (fun () -> 
    let bcs_printf fmt = 
      let k result = match how with 
      | Save_BCS_OC(oc) -> output_string oc result
--- 183,375 ----
    | Save_BCS_OC of out_channel
    | Save_BCS_Buffer of Buffer.t
  
+ let check_file_presence_trigger string script_style ids game first_or_second_string =
+   if Modder.get "MISSING_RESREF" = Modder.None then ()
+   else (* if script_style = Load.BG then *)
+     (
+     if string <> "" then begin
+       let ext = match ids with
+         | 0x0001l (* Acquired(S:Resref.) *)
+         | 0x0009l (* Unusable(S:Resref.) *)
+         | 0x4042l (* PartyHasItem(S:Resref.) *)
+         | 0x4061l (* HasItem(S:Item.,O:) *)
+         | 0x4075l (* Contains(S:,O:) *)
+         | 0x4077l (* NumItems(S:,I) *)
+         | 0x4078l (* NumItemsLT(S:,I) *)
+         | 0x4079l (* NumItemsGT(S:,I) *)
+         | 0x407Al (* NumItemsParty(S:,I) *)
+         | 0x407Bl (* NumItemsPartyLT(S:,I) *)
+         | 0x407Cl (* NumItemsPartyGT(S:,I) *)
+         | 0x407Fl (* HasItemEquiped(S:) *)
+         | 0x40A9l (* PartyHasItemIdentified(S:) *)
+         | 0x40C2l (* HasItemRealEquiped(S:) *)
+         -> "itm"
+ 
+         | 0x407El (* AreaCheck(S:) *)
+         | 0x40D4l (* AreaCheck(S:) *)
+         -> "are"
+ 
+         | 0x4031l (* HaveSpellRes *)
+         -> "spl"
+ 
+         | _ -> ""
+       in
+ 
+       if ext <> "" then begin
+         if not (try
+         Load.skip_next_load_error := true;
+         let buff,path = Load.load_resource "FILE_EXISTS_IN_GAME" game true string ext in
+           (String.length buff > 0) with | Invalid_argument "String.create" -> true
+ 					| _ -> false )
+         then (Modder.handle_deb "MISSING_RESREF"
+ 				(Printf.sprintf "POSSIBLE ERROR: file %s.%s is not found in trigger %d.\n" string ext (Int32.to_int ids)))
+ 
+       end
+     end
+     ) ;
+   ()
+ 
+ let check_file_presence_action string script_style ids game first_or_second_string =
+   if Modder.get "MISSING_RESREF" = Modder.None then ()
+   else (* if script_style = Load.BG then *)
+     (
+     if string <> "" then begin
+       let ext = match ids with
+         | 9l   (* DropItem *)
+         | 11l  (* EquipItem *)
+         | 14l  (* GetItem *)
+         | 15l  (* GiveItem *)
+         | 34l  (* UseItem *)
+         | 82l  (* CreateItem *)
+         | 97l  (* UseItemPoint *)
+         | 116l (* TakePartyItem *)
+         | 140l (* GiveItemCreate *)
+         | 169l (* DestroyItem *)
+         | 188l (* TakeItemPartyAll *)
+         | 193l (* TakePartyItemRange *)
+         | 204l (* TakePartyItemNum *)
+         | 257l (* PickUpItem *)
+         | 278l (* GiveItemReplace *)
+         | 292l (* DisplayStringOverHeadOwner *)
+         -> [ "itm" ]
+ 
+         | 91l  (* LeaveArea *)
+         | 108l (* EscapeAreaMove *)
+         | 110l (* LeaveAreaLUA *)
+         | 170l (* RevealAreaOnMap *)
+         | 185l (* SetMasterArea *) (* Remember to check wether it's BCS or ARE *)
+         | 189l (* LeaveAreaLUAPanic *)
+         | 197l (* MoveAreaGlobal *)
+         | 251l (* HideAreaOnMap *)
+         | 264l (* CopyGroundPilesTo *)
+         | 277l (* EscapeAreaObjectMove *)
+         | 310l (* MoveGlobalsTo *)
+         | 347l (* SetEncounterProbability *)
+         -> [ "are" ]
+ 
+         | 225l (* MoveBetweenAreas *)
+         | 350l (* LeaveAreaLuaEntry *)
+         | 351l when first_or_second_string = 1 (* LeaveAreaLuaEntryPanic *)
+         -> [ "are" ]
+ 
+         | 279l (* AddSpecialAbility *)
+         | 31l  (* SpellRES *)
+         | 95l  (* SpellPointRES *)
+         | 113l (* ForceSpellRES *)
+         | 114l (* ForceSpellPointRES *)
+         | 160l (* ApplySpellRES *)
+         | 181l (* ReallyForceSpellRES *)
+         | 191l (* SpellNoDecRES *)
+         | 192l (* SpellPointNoDecRES *)
+         | 240l (* ReallyForceSpellDeadRES *)
+         | 318l (* ForceSpellRangeRES *)
+         | 319l (* ForceSpellPointRangeRES *)
+         | 337l (* ReallyForceSpellPointRES *)
+         -> [ "spl" ]
+ 
+         | 7l   (* CreateCreature *)
+         | 194l (* ChangeAnimation (takes a cre) *)
+         | 219l (* ChangeAnimationNoEffect (see above) *)
+         | 228l (* CreateCreatureImpassable *)
+         | 231l (* CreateCreatureDoor *)
+         | 232l (* CreateCreatureObjectDoor *)
+         | 233l (* CreateCreatureObjectOffScreen *)
+         | 238l (* CreateCreatureOffscren *)
+         | 252l (* CreateCreatureObjectOffset *)
+         | 295l (* CreateCreatureCopyPoint *)
+         | 323l (* CreateCreatureImpassableAllowOverlap *)
+         -> [ "cre" ]
+ 
+         | 250l (* CreateCreatureObjectCopy *)
+         | 227l when first_or_second_string = 1 (* CreateCreatureObject *)
+         -> [ "cre" ]
+ 
+         | 26l (* PlaySound *)
+         -> [ "wav" ]
+ 
+         | 60l  (* ChangeAIScript *)
+         | 120l (* StartCutScene *)
+         -> [ "bcs" ]
+ 
+         | 137l (* StartDialog(ue) *)
+         | 138l (* SetDialog(ue) *)
+         | 266l (* StartDialog(ue)Interrupt *)
+         | 293l (* StartDialogueOverride *)
+         | 294l (* StartDialogueOverrideInterrupt *)
+         | 334l (* StartDialogueNoName *)
+         -> [ "dlg" ]
+ 
+         | 150l (* StartStore *)
+         -> [ "sto" ]
+ 
+         | 161l (* IncrementChapter *)
+         | 199l (* TextScreen *)
+         | 220l (* TakeItemPartyList *)
+         | 226l (* TakeItemPartyListNum *)
+         -> [ "2da" ]
+ 
+         | 167l (* StartMovie *)
+         -> [ "mve" ]
+ 
+         | 272l (* CreateVisualEffectPoint *)
+         | 273l (* CreateVisualEffectObject *)
+         -> [ "vvc"; "bam" ]
+ 
+         | 341l (* StaticPalette *) (* Ask wether it's really a bmp file *)
+         -> [ "bmp" ]
+ 
+         | 225l (* MoveBetweenAreasEffect *)
+         | 227l (* CreateCreatureObjectEffect *)
+         | 250l when first_or_second_string = 2 (* CreateCreatureObjectCopyEffect *)
+         -> [ "vvc"; "bam" ]
+ 
+         | _ -> []
+       in
+ 
+       if ext <> [] then begin
+         let result = ref false in
+         let put_or = ref false in
+         List.iter (fun ext_s -> 
+           try
+ (*             log_and_print "Looking for %s.%s\n" string ext_s ; *)
+             Load.skip_next_load_error := true;
+             let buff,path = Load.load_resource "FILE_EXISTS_IN_GAME" game true string ext_s in
+             result := !result or ( String.length buff > 0 ) ;
+           with | Invalid_argument "String.create" -> result := true
+ 					| _ -> ()
+         ) ext ;
+         if not !result then ( Modder.handle_deb "MISSING_RESREF"
+ 					(Printf.sprintf "POSSIBLE ERROR: file %s.%s is not found in action %d.\n" string (List.fold_left
+ 	        (fun acc this -> acc ^ (if not !put_or then (put_or:=true ; this) else ( "/" ^ this))) "" ext)
+ 	        (Int32.to_int ids)))
+ 
+       end
+     end
+     ) ;
+   ()
+ 
  let save_bcs game how bcs =
!   Stats.time "marshal BCS" (fun () ->
    let bcs_printf fmt = 
      let k result = match how with
      | Save_BCS_OC(oc) -> output_string oc result
***************
*** 178,183 ****
--- 388,395 ----
      List.iter (save_r game ) rl ;
      bcs_printf "RS\nCR\n"
    and save_t game t =
+     check_file_presence_trigger t.t_3 game.Load.script_style t.trigger_id game 1 ;
+     check_file_presence_trigger t.t_4 game.Load.script_style t.trigger_id game 2 ;
      begin
      match game.Load.script_style with
      | Load.PST ->
***************
*** 185,191 ****
        bcs_printf "TR\n%ld %ld %d %ld %ld [%ld,%ld] \"%s\" \"%s\" "
          t.trigger_id t.t_1 (if t.negated then 1 else 0)
          t.t_2 t.unknown x y t.t_3 t.t_4 ;
!     | Load.BG
      | Load.IWD2 -> 
        (* IWD2 NearLocation(Myself,111,222,333)
         * -> TR\n16553 111 0 222 333 "" ""
--- 397,405 ----
        bcs_printf "TR\n%ld %ld %d %ld %ld [%ld,%ld] \"%s\" \"%s\" "
          t.trigger_id t.t_1 (if t.negated then 1 else 0)
          t.t_2 t.unknown x y t.t_3 t.t_4 ;
!     | Load.BG1
!     | Load.BG2
!     | Load.IWD1
      | Load.IWD2 ->
        (* IWD2 NearLocation(Myself,111,222,333)
         * -> TR\n16553 111 0 222 333 "" ""
***************
*** 193,198 ****
--- 407,413 ----
        bcs_printf "TR\n%ld %ld %d %ld %ld \"%s\" \"%s\" "
          t.trigger_id t.t_1 (if t.negated then 1 else 0)
          t.t_2 t.unknown t.t_3 t.t_4 ;
+     | Load.NONE -> failwith "No scripting style specified."
      end ;
      save_obj game t.t_5 ;
      bcs_printf "TR\n" 
***************
*** 201,206 ****
--- 416,423 ----
      List.iter (save_a game) al ;
      bcs_printf "RE\n" ;
    and save_a game a =
+     check_file_presence_action a.a_8 game.Load.script_style a.action_id game 1 ;
+     check_file_presence_action a.a_9 game.Load.script_style a.action_id game 2 ;
      bcs_printf "AC\n%ld" a.action_id;
      save_obj game a.a_1 ;
      save_obj game a.a_2 ;
***************
*** 216,232 ****
        obj.o_ea
        obj.o_general
        obj.o_race
!       0l (* obj.o_subrace *) (* NO CLUE JONES! THIS DOES NOT WORK *) 
        obj.o_specific
        obj.o_gender
        obj.o_alignment
!       0l (* obj.o_class *) (* NO CLUE JONES! THIS DOES NOT WORK *) 
        obj.o_identifiers obj.o_unknown1 obj.o_unknown2
        obj.o_unknown3 obj.o_unknown4 
        w x y z 
        obj.o_name
        obj.o_iwd2_1 obj.o_iwd2_2 
!     | Load.BG -> 
      bcs_printf "OB\n%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld \"%s\"OB\n"
        obj.o_ea obj.o_general obj.o_race obj.o_class
        obj.o_specific obj.o_gender obj.o_alignment 
--- 433,451 ----
        obj.o_ea
        obj.o_general
        obj.o_race
!       obj.o_subrace (* NO CLUE JONES! THIS DOES NOT WORK *) 
        obj.o_specific
        obj.o_gender
        obj.o_alignment
!       obj.o_class (* NO CLUE JONES! THIS DOES NOT WORK *) 
        obj.o_identifiers obj.o_unknown1 obj.o_unknown2
        obj.o_unknown3 obj.o_unknown4 
        w x y z 
        obj.o_name
        obj.o_iwd2_1 obj.o_iwd2_2 
!     | Load.BG1
!     | Load.BG2
!     | Load.IWD1 ->
      bcs_printf "OB\n%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld \"%s\"OB\n"
        obj.o_ea obj.o_general obj.o_race obj.o_class
        obj.o_specific obj.o_gender obj.o_alignment 
***************
*** 241,246 ****
--- 460,466 ----
        obj.o_unknown3 obj.o_unknown4
        w x y z
        obj.o_name
+     | Load.NONE -> failwith "No scripting style specified."
    in
    save_bcs game bcs 
    ) () 
***************
*** 281,298 ****
    with e -> begin
      let buff,path = Load.load_resource "get_ids_map" game true ids_filename "IDS" in 
      let where_newline = String.index buff '\n' in
!     let buff = Str.string_after buff where_newline in 
      let lexbuf = lex_init_from_string ids_filename buff in 
!     let lexer = if game.Load.script_style = Load.IWD2 && 
                  ids_filename <> "ACTION" &&
!                 ids_filename <> "TRIGGER" then 
            Idslexer2.initial 
        else Idslexer.initial 
      in 
      let result = Stats.time "parsing .ids files" (fun () ->
        Idsparser.ids_file lexer lexbuf) () in
      pop_context () ; 
!     log_or_print "[%s.IDS] parsed\n" ids_filename ;
      let ids_map = make_ids_map result in 
      let my_ids_state = try 
        Hashtbl.find all_games_ids_state game.Load.game_path 
--- 501,521 ----
    with e -> begin
      let buff,path = Load.load_resource "get_ids_map" game true ids_filename "IDS" in 
      let where_newline = String.index buff '\n' in
!     let before = Str.string_before buff where_newline in
!     let ok = Str.string_match (Str.regexp "[0-9][0-9]* .*") before 0 in
!     let buff = if ok then buff else Str.string_after buff where_newline in
!     if !debug_ocaml then log_and_print "%s.ids: the first line is %sOK\n" ids_filename (if ok then "" else "not ");
      let lexbuf = lex_init_from_string ids_filename buff in
!     let lexer = if ((game.Load.script_style = Load.IWD1 || game.Load.script_style = Load.IWD2) &&
                      ids_filename <> "ACTION" &&
!                     ids_filename <> "TRIGGER" ) then
          Idslexer2.initial
        else Idslexer.initial
      in
      let result = Stats.time "parsing .ids files" (fun () ->
        Idsparser.ids_file lexer lexbuf) () in
      pop_context () ; 
!     log_or_print_modder "[%s.IDS] parsed\n" ids_filename ;
      let ids_map = make_ids_map result in 
      let my_ids_state = try 
        Hashtbl.find all_games_ids_state game.Load.game_path 
***************
*** 347,355 ****
    | _, 30l (*SetGlobal(S:Name.,S:Area.,I:Value.)*)
    | _, 115l (*SetGlobalTimer(S:Name.,S:Area.,I:Time.GTimes)*)
    | _, 109l (*IncrementGlobal(S:Name.,S:Area.,I:Value.)*)
!   | Load.BG, 246l (*CreateCreatureAtLocation(S:GLOBAL.,S:Area.,S:ResRef.)*)
    | _, 256l (*CreateItemGlobal(S:Global.,S:Area.,S:ResRef.)*)
    | _, 268l (* RealSetGlobalTimer(S:Name*,S:Area*,I:Time*GTimes) *)
    | _, 335l (* SetTokenGlobal(S:GLOBAL.,S:Area.,S:Token.) *)
    | Load.PST, 227l (* GlobalBAND(S:Name*,S:Area*,I:Value *)
    | Load.PST, 228l (* GlobalBOR(S:Name*,S:Area*,I:Value *)
--- 570,581 ----
    | _, 30l (*SetGlobal(S:Name.,S:Area.,I:Value.)*)
    | _, 115l (*SetGlobalTimer(S:Name.,S:Area.,I:Time.GTimes)*)
    | _, 109l (*IncrementGlobal(S:Name.,S:Area.,I:Value.)*)
!   | Load.BG1, 246l (*CreateCreatureAtLocation(S:GLOBAL.,S:Area.,S:ResRef.)*)
!   | Load.BG2, 246l (*CreateCreatureAtLocation(S:GLOBAL.,S:Area.,S:ResRef.)*)
    | _, 256l (*CreateItemGlobal(S:Global.,S:Area.,S:ResRef.)*)
    | _, 268l (* RealSetGlobalTimer(S:Name*,S:Area*,I:Time*GTimes) *)
+   | Load.BG1, 297l (* MoveToSavedLocation(S:*,S:* ) *)
+   | Load.BG2, 297l (* MoveToSavedLocation(S:*,S:* ) *)
    | _, 335l (* SetTokenGlobal(S:GLOBAL.,S:Area.,S:Token.) *)
    | Load.PST, 227l (* GlobalBAND(S:Name*,S:Area*,I:Value *)
    | Load.PST, 228l (* GlobalBOR(S:Name*,S:Area*,I:Value *)
***************
*** 367,372 ****
--- 593,603 ----
    | Load.PST, 0x4080l (* GlobalBAND(S:Name*,S:Area*,I:Value *)
    | Load.PST, 0x4095l (* Xor(S:Name*,S:Area*,I:Value*)
    | Load.PST, 0x409Cl (* StuffGlobalRandom(S:Name*,S:Area*,I:Range*)
+   | Load.IWD2, 247l   (* BitGlobal(S:String1*,S:String2*,I:Value,I:Mode*BitMode) *)
+   | Load.IWD2, 0x40A5l (* BitGlobal(S:String1*,S:String2*,I:Value,I:Mode*BitMode) *)
+   | Load.IWD2, 306l    (* SetGlobalRandom(S:Name*,S:Area*,I:Min*,I:Max*)
+   | Load.IWD2, 307l    (* SetGlobalTimerRandom(S:Name*,S:Area*,I:Min*,I:Max*)
+   | Load.IWD2, 308l (*SetGlobalTimerOnce(S:Name*,S:Area*,I:Time*GTimes) *)
        -> 1
    | Load.PST, 233l (* GlobalSetGlobal(S:Name1*,S:Area1*,S:Name2*,S:Area2 *)
    | Load.PST, 234l (* GlobalAddGlobal(S:Name1*,S:Area1*,S:Name2*,S:Area2 *)
***************
*** 387,406 ****
    | Load.PST, 0x4086l (* GlobalORGlobal(S:Name1*,S:Area1*,S:Name2*,S:Area2*)
    | Load.PST, 0x4087l (* GlobalBANDGlobal(S:Name1*,S:Area1*,S:Name2*,S:Area2*)
    | Load.PST, 0x4088l (* GlobalBANDGlobalExact(S:Name1*,S:Area1*,S:Name2*,S:Area2*)
!   | _, 202l (* IncrementGlobalOnce(S:Name1*,S:Area1*,S:Name2*,S:Area2*,I:Val*)
        -> 2 
  
    | _ -> 0
  
  
  
  let split6 s =
    if String.length s >= 6 then 
!     (String.sub s 6 ((String.length s) - 6) ,
!      String.sub s 0 6 )
    else
      "",s
  
  let rec best_ids_of_trigger game c =
    let ids = every_ids_of_int game "TRIGGER" c.trigger_id in 
    if ids = [] then begin
--- 618,654 ----
    | Load.PST, 0x4086l (* GlobalORGlobal(S:Name1*,S:Area1*,S:Name2*,S:Area2*)
    | Load.PST, 0x4087l (* GlobalBANDGlobal(S:Name1*,S:Area1*,S:Name2*,S:Area2*)
    | Load.PST, 0x4088l (* GlobalBANDGlobalExact(S:Name1*,S:Area1*,S:Name2*,S:Area2*)
!   | Load.IWD1, 243l   (* IncrementGlobalOnce(S:Name1*,S:Area1*,S:Name2*,S:Area2*,I:Val*)
!   | Load.IWD2, 243l   (* IncrementGlobalOnce(S:Name1*,S:Area1*,S:Name2*,S:Area2*,I:Val*)
!   | Load.PST, 202l    (* IncrementGlobalOnce(S:Name1*,S:Area1*,S:Name2*,S:Area2*,I:Val*)
!   | Load.IWD2, 248l   (* GlobalBitGlobal(S:String1*,S:String2*,I:Value,I:Mode*BitMode) *)
!   | Load.IWD2, 0x40A6l (* GlobalBitGlobal(S:String1*,S:String2*,I:Value,I:Mode*BitMode) *)
        -> 2
  
+   | Load.IWD2, 289l   (* SpellCastEffect(O:Source*,S:Voice*,S:Sound1*,S:Sound2*,I:Animation*sceffect,I:Speed*,I:Sequence*Sequence) *)
+       -> 3
+ 
+   | Load.NONE,_ -> failwith "No scripting style specified."
    | _ -> 0
  
  
  
  let split6 s =
    if String.length s >= 6 then
!     begin
! 	    let (name,scope) = (String.sub s 6 ((String.length s) - 6) ,
! 	     String.sub s 0 6 ) in
! 	    if name.[0] = ':' then (String.sub name 1 ((String.length name) -1),scope) else (name,scope)
! 		end
    else
      "",s
  
+ let splitc s =
+   let c = String.index s ':' in
+   ( String.sub s (c+1) ((String.length s) - c - 1) ,
+     String.sub s 0 c )
+ 
+ 
  let rec best_ids_of_trigger game c =
    let ids = every_ids_of_int game "TRIGGER" c.trigger_id in 
    if ids = [] then begin
***************
*** 472,479 ****
  | BCS_Print_ActionList of action list 
  | BCS_Print_TriggerList of trigger list 
  
! let trigger_to_arg_list ss t ids = 
    match is_concat_string ss ids with
    | 2 (* FIXME *) 
    | 1 -> 
      let a,b = split6 t.t_3 in
--- 720,728 ----
  | BCS_Print_ActionList of action list 
  | BCS_Print_TriggerList of trigger list
  
! let trigger_to_arg_list ss t ids game =
    match is_concat_string ss ids with
+   | 3 (* FIXME *)
    | 2 (* FIXME *)
    | 1 ->
      let a,b = split6 t.t_3 in
***************
*** 522,527 ****
--- 771,788 ----
        (Arg_String,(Act_String b)) ;
        (Arg_String,(Act_String aa')) ;
        (Arg_String,(Act_String b')) ]
+   | 3 ->
+       let aa,b = splitc a.a_9 in
+     [ (Arg_Object,(Act_Object a.a_2)) ;
+       (Arg_Object,(Act_Object a.a_3)) ;
+       (* (Arg_Object,(Act_Object a.a_1)) ; *)
+       (Arg_Integer,(Act_Integer a.a_4)) ;
+       (Arg_Point,(Act_Point a.a_5)) ;
+       (Arg_Integer,(Act_Integer a.a_6)) ;
+       (Arg_Integer,(Act_Integer a.a_7)) ;
+       (Arg_String,(Act_String a.a_8)) ;
+       (Arg_String,(Act_String aa)) ;
+       (Arg_String,(Act_String b)) ; ]
    | _ ->
      [ (Arg_Object,(Act_Object a.a_2)) ;
        (Arg_Object,(Act_Object a.a_3)) ;
***************
*** 585,596 ****
          obj.o_general , "GENERAL" ;
          obj.o_race , "RACE" ;
          obj.o_subrace , "SUBRACE" ;
-         obj.o_class , "CLASS" ;
          obj.o_specific , "SPECIFIC" ;
          obj.o_gender , "GENDER" ;
!         obj.o_alignment , "ALIGNMNT" 
        ] 
!       | Load.BG -> [ 
          obj.o_ea , "EA" ;
          obj.o_general , "GENERAL" ;
          obj.o_race , "RACE" ;
--- 846,861 ----
          obj.o_general , "GENERAL" ;
          obj.o_race , "RACE" ;
          obj.o_subrace , "SUBRACE" ;
          obj.o_specific , "SPECIFIC" ;
          obj.o_gender , "GENDER" ;
!         obj.o_alignment , "ALIGNMNT" ;
!         obj.o_class , "CLASS" ;
!         obj.o_iwd2_1 , "AVCLASS" ;
!         obj.o_iwd2_2 , "CLASSMSK"
        ] 
!       | Load.BG1
!       | Load.BG2
!       | Load.IWD1 -> [
          obj.o_ea , "EA" ;
          obj.o_general , "GENERAL" ;
          obj.o_race , "RACE" ;
***************
*** 608,613 ****
--- 873,879 ----
          obj.o_specific , "SPECIFIC" ;
          obj.o_gender , "GENDER" ;
          obj.o_alignment , "ALIGN" ] 
+     | Load.NONE -> failwith "No scripting style specified."
        in
  
        let rec all_zeros lst = match lst with
***************
*** 630,646 ****
          end
        in 
  
        let rec proc lst lp rp anything = match lst with
        | [] -> 
            begin
              if all_zeros dotlst then begin
!               (if not anything && obj.o_name = "" then bcs_printf "[ANYONE]"
!                else if obj.o_name <> "" then bcs_printf "%s\"%s\"%s" lp obj.o_name rp)
              end else begin
                bcs_printf"%s[" lp ;
                proc_dot dotlst ;
!               bcs_printf "]%s" rp ;
!             end
            end 
        | hd :: tl ->
              if hd = 0l then
--- 896,919 ----
          end
        in
  
+ 			let get_rect rect =
+ 			  if (game.Load.script_style = Load.IWD2 ||game.Load.script_style = Load.PST ) && rect <> (-1l,-1l,-1l,-1l) then begin
+ 				  let (a,b,c,d) = rect in
+ 				  Printf.sprintf "[%ld.%ld.%ld.%ld]" a b c d;
+ 			  end else ""
+ 			in
        let rec proc lst lp rp anything = match lst with
        | [] ->
            begin
              if all_zeros dotlst then begin
!               if not anything && obj.o_name = "" then bcs_printf "[ANYONE]%s" (get_rect obj.o_rect)
!                else (if obj.o_name <> "" then bcs_printf "%s\"%s\"%s%s" lp obj.o_name (get_rect obj.o_rect) rp
!                else bcs_printf "%s" (get_rect obj.o_rect))
              end else begin
                bcs_printf"%s[" lp ;
                proc_dot dotlst ;
!               bcs_printf "]%s%s" (get_rect obj.o_rect) rp;
!             end;
            end
        | hd :: tl ->
              if hd = 0l then
***************
*** 740,746 ****
      if (t.negated) then bcs_printf "!" ;
      let ids = best_ids_of_trigger game t in 
      bcs_printf "%s(" ids.i_name ; 
!     let argl = ref (trigger_to_arg_list game.Load.script_style t ids) in 
      print_arg_list argl ids ; 
      bcs_printf ")" ;
      if comments then begin 
--- 1013,1019 ----
      if (t.negated) then bcs_printf "!" ;
      let ids = best_ids_of_trigger game t in
      bcs_printf "%s(" ids.i_name ;
!     let argl = ref (trigger_to_arg_list game.Load.script_style t ids game) in
      print_arg_list argl ids ;
      bcs_printf ")" ;
      if comments then begin
