*** WeiDU-185/src/var.ml	Wed May 18 21:42:12 2005
--- WeiDU/src/var.ml	Fri Jun  6 14:56:53 2008
***************
*** 1,7 ****
--- 1,17 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.var.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (*
   * TP2 Patch Variables
   *)
  
+ open Util
+ 
  let debug_assign = ref false 
  
  type variable_value = 
***************
*** 10,20 ****
--- 20,36 ----
  
  let variables = Hashtbl.create 255
  
+ let arrays : (string, string list list) Hashtbl.t = Hashtbl.create 255
+ 
+ let cli_variables : string list option ref = ref None
+ 
  let set_int32 name value =
    let name = "%" ^ name ^ "%" in
    (if !debug_assign then Util.log_and_print "SET %s = %ld\n" name value) ;
    Hashtbl.replace variables name (Int32(value))
  
+ let set_int name value = set_int32 name (Int32.of_int value)
+ 
  let get_int32 name =
    match Hashtbl.find variables name with
    | Int32(v) -> v
***************
*** 25,52 ****
    (if !debug_assign then Util.log_and_print "SET %s = ~%s~\n" name value) ; 
    Hashtbl.replace variables name (String(value))
  
  let variable_regexp = Str.regexp "%[^%]+%" 
  
! let get_string str =
    let res = 
!   Str.global_substitute variable_regexp 
      (fun whole_thing -> (* "%foo%" *)
        let quoted_substr = Str.matched_string whole_thing in 
        try
          (match Hashtbl.find variables quoted_substr with
          | Int32(v) -> Int32.to_string v
          | String(s) -> s) 
        with Not_found -> quoted_substr 
      ) str
    in 
    (if !debug_assign then Util.log_and_print "GET ~%s~ = ~%s~\n" str res) ; 
    res
  
  let assoc name value = 
    let value = Int32.of_int value in 
    Hashtbl.replace variables name (Int32 value) 
  
! let _ = 
    assoc "AREA_CITY" 0252 ;
    assoc "AREA_DAY" 0260 ;
    assoc "AREA_DUNGEON" 0256 ;
--- 41,104 ----
    (if !debug_assign then Util.log_and_print "SET %s = ~%s~\n" name value) ;
    Hashtbl.replace variables name (String(value))
  
+ let add_local_int32 name value =
+   let name = "%" ^ name ^ "%" in
+   (if !debug_assign then Util.log_and_print "SET %s = %ld\n" name value) ;
+   Hashtbl.add variables name (Int32(value))
+ 
+ let add_local_string name value =
+   let name = "%" ^ name ^ "%" in
+   (if !debug_assign then Util.log_and_print "LOCAL_SET %s = ~%s~\n" name value) ;
+   Hashtbl.add variables name (String(value))
+ 
+ let remove_local name =
+   let name = "%" ^ name ^ "%" in
+   Hashtbl.remove variables name
+ 
  let variable_regexp = Str.regexp "%[^%]+%"
  
! let get_string_special reg str =
    let res =
!   Str.global_substitute reg
      (fun whole_thing -> (* "%foo%" *)
        let quoted_substr = Str.matched_string whole_thing in
        try
          (match Hashtbl.find variables quoted_substr with
          | Int32(v) -> Int32.to_string v
          | String(s) -> s)
+       with Not_found -> if reg <> variable_regexp then begin
+ 	      try
+ 	      	let try_substr = String.sub quoted_substr 1 (String.length quoted_substr - 2) in
+ 	      	let try_substr = "%" ^ try_substr ^ "%" in
+ 	        (match Hashtbl.find variables try_substr with
+ 	        | Int32(v) -> Int32.to_string v
+ 	        | String(s) -> s)
  	      with Not_found ->  quoted_substr
+ 			end else quoted_substr
      ) str
    in
    (if !debug_assign then Util.log_and_print "GET ~%s~ = ~%s~\n" str res) ;
    res
  
+ let get_string = get_string_special variable_regexp
+ 
+ let get_string_exact str =
+   match Hashtbl.find variables str with
+   | Int32(v) -> Int32.to_string v
+   | String(s) -> s
+ 
+ 
+ let clear_var a =
+   let var_spec = Hashtbl.copy variables in
+   Hashtbl.iter ( fun a b -> Hashtbl.remove variables a 
+   ) var_spec ;
+   Hashtbl.clear variables
+ 
  let assoc name value =
    let value = Int32.of_int value in
    Hashtbl.replace variables name (Int32 value)
  
! let all_the_assoc a =
    assoc "AREA_CITY" 0252 ;
    assoc "AREA_DAY" 0260 ;
    assoc "AREA_DUNGEON" 0256 ;
***************
*** 150,152 ****
--- 202,208 ----
  
    ()
  
+ let _ =
+   all_the_assoc () ;
+   ()
+ 
