*** WeiDU-185/zlib/zutil.h	Fri Sep 27 03:16:30 2002
--- WeiDU/zlib/zutil.h	Sat Sep  1 02:40:48 2007
***************
*** 1,5 ****
  /* zutil.h -- internal interface and configuration of the compression library
!  * Copyright (C) 1995-2002 Jean-loup Gailly.
   * For conditions of distribution and use, see copyright notice in zlib.h
   */
  
--- 1,5 ----
  /* zutil.h -- internal interface and configuration of the compression library
!  * Copyright (C) 1995-2006 Jean-loup Gailly.
   * For conditions of distribution and use, see copyright notice in zlib.h
   */
  
***************
*** 10,26 ****
  
  /* @(#) $Id$ */
  
! #ifndef _Z_UTIL_H
! #define _Z_UTIL_H
  
  #include "zlib.h"
  
  #ifdef STDC
  #  include <stddef.h>
  #  include <string.h>
  #  include <stdlib.h>
  #endif
! #ifdef NO_ERRNO_H
      extern int errno;
  #else
  #   include <errno.h>
--- 10,37 ----
  
  /* @(#) $Id$ */
  
! #ifndef ZUTIL_H
! #define ZUTIL_H
  
+ #define ZLIB_INTERNAL
  #include "zlib.h"
  
  #ifdef STDC
+ #  ifndef _WIN32_WCE
  #    include <stddef.h>
+ #  endif
  #  include <string.h>
  #  include <stdlib.h>
  #endif
! #if defined(NO_ERRNO_H) || defined(_WIN32_WCE)
! #   ifdef _WIN32_WCE
!       /* The Microsoft C Run-Time Library for Windows CE doesn't have
!        * errno.  We define it as a global variable to simplify porting.
!        * Its value is always 0 and should not be used.  We rename it to
!        * avoid conflict with other libraries that use the same workaround.
!        */
! #     define errno z_errno
! #   endif
      extern int errno;
  #else
  #   include <errno.h>
***************
*** 37,43 ****
  typedef ush FAR ushf;
  typedef unsigned long  ulg;
  
! extern const char *z_errmsg[10]; /* indexed by 2-zlib_error */
  /* (size given to avoid silly warnings with Visual C++) */
  
  #define ERR_MSG(err) z_errmsg[Z_NEED_DICT-(err)]
--- 48,54 ----
  typedef ush FAR ushf;
  typedef unsigned long  ulg;
  
! extern const char * const z_errmsg[10]; /* indexed by 2-zlib_error */
  /* (size given to avoid silly warnings with Visual C++) */
  
  #define ERR_MSG(err) z_errmsg[Z_NEED_DICT-(err)]
***************
*** 73,79 ****
  
          /* target dependencies */
  
! #ifdef MSDOS
  #  define OS_CODE  0x00
  #  if defined(__TURBOC__) || defined(__BORLANDC__)
  #    if(__STDC__ == 1) && (defined(__LARGE__) || defined(__COMPACT__))
--- 84,90 ----
  
          /* target dependencies */
  
! #if defined(MSDOS) || (defined(WINDOWS) && !defined(WIN32))
  #  define OS_CODE  0x00
  #  if defined(__TURBOC__) || defined(__BORLANDC__)
  #    if(__STDC__ == 1) && (defined(__LARGE__) || defined(__COMPACT__))
***************
*** 88,99 ****
  #  endif
  #endif
  
! #ifdef OS2
! #  define OS_CODE  0x06
! #endif
! 
! #ifdef WIN32 /* Window 95 & Windows NT */
! #  define OS_CODE  0x0b
  #endif
  
  #if defined(VAXC) || defined(VMS)
--- 99,106 ----
  #  endif
  #endif
  
! #ifdef AMIGA
! #  define OS_CODE  0x01
  #endif
  
  #if defined(VAXC) || defined(VMS)
***************
*** 102,115 ****
       fopen((name), (mode), "mbc=60", "ctx=stm", "rfm=fix", "mrs=512")
  #endif
  
- #ifdef AMIGA
- #  define OS_CODE  0x01
- #endif
- 
  #if defined(ATARI) || defined(atarist)
  #  define OS_CODE  0x05
  #endif
  
  #if defined(MACOS) || defined(TARGET_OS_MAC)
  #  define OS_CODE  0x07
  #  if defined(__MWERKS__) && __dest_os != __be_os && __dest_os != __win32_os
--- 109,125 ----
       fopen((name), (mode), "mbc=60", "ctx=stm", "rfm=fix", "mrs=512")
  #endif
  
  #if defined(ATARI) || defined(atarist)
  #  define OS_CODE  0x05
  #endif
  
+ #ifdef OS2
+ #  define OS_CODE  0x06
+ #  ifdef M_I86
+      #include <malloc.h>
+ #  endif
+ #endif
+ 
  #if defined(MACOS) || defined(TARGET_OS_MAC)
  #  define OS_CODE  0x07
  #  if defined(__MWERKS__) && __dest_os != __be_os && __dest_os != __win32_os
***************
*** 121,144 ****
  #  endif
  #endif
  
- #ifdef __50SERIES /* Prime/PRIMOS */
- #  define OS_CODE  0x0F
- #endif
- 
  #ifdef TOPS20
  #  define OS_CODE  0x0a
  #endif
  
  #if defined(_BEOS_) || defined(RISCOS)
  #  define fdopen(fd,mode) NULL /* No fdopen() */
  #endif
  
! #if (defined(_MSC_VER) && (_MSC_VER > 600))
  #  define fdopen(fd,type)  _fdopen(fd,type)
  #endif
  
  
!         /* Common defaults */
  
  #ifndef OS_CODE
  #  define OS_CODE  0x03  /* assume Unix */
--- 131,173 ----
  #  endif
  #endif
  
  #ifdef TOPS20
  #  define OS_CODE  0x0a
  #endif
  
+ #ifdef WIN32
+ #  ifndef __CYGWIN__  /* Cygwin is Unix, not Win32 */
+ #    define OS_CODE  0x0b
+ #  endif
+ #endif
+ 
+ #ifdef __50SERIES /* Prime/PRIMOS */
+ #  define OS_CODE  0x0f
+ #endif
+ 
  #if defined(_BEOS_) || defined(RISCOS)
  #  define fdopen(fd,mode) NULL /* No fdopen() */
  #endif
  
! #if (defined(_MSC_VER) && (_MSC_VER > 600)) && !defined __INTERIX
! #  if defined(_WIN32_WCE)
! #    define fdopen(fd,mode) NULL /* No fdopen() */
! #    ifndef _PTRDIFF_T_DEFINED
!        typedef int ptrdiff_t;
! #      define _PTRDIFF_T_DEFINED
! #    endif
! #  else
  #    define fdopen(fd,type)  _fdopen(fd,type)
  #  endif
+ #endif
  
+ #if defined(__BORLANDC__)
+ #pragma warn -8004
+ #pragma warn -8008
+ #pragma warn -8066
+ #endif
  
!         /* common defaults */
  
  #ifndef OS_CODE
  #  define OS_CODE  0x03  /* assume Unix */
***************
*** 148,160 ****
  #  define F_OPEN(name, mode) fopen((name), (mode))
  #endif
  
           /* functions */
  
! #ifdef HAVE_STRERROR
!    extern char *strerror OF((int));
! #  define zstrerror(errnum) strerror(errnum)
! #else
! #  define zstrerror(errnum) ""
  #endif
  
  #if defined(pyr)
--- 177,221 ----
  #  define F_OPEN(name, mode) fopen((name), (mode))
  #endif
  
+ #ifdef _LARGEFILE64_SOURCE
+ #  define F_OPEN64(name, mode) fopen64((name), (mode))
+ #else
+ #  define F_OPEN64(name, mode) fopen((name), (mode))
+ #endif
+ 
           /* functions */
  
! #if defined(STDC99) || (defined(__TURBOC__) && __TURBOC__ >= 0x550)
! #  ifndef HAVE_VSNPRINTF
! #    define HAVE_VSNPRINTF
! #  endif
! #endif
! #if defined(__CYGWIN__)
! #  ifndef HAVE_VSNPRINTF
! #    define HAVE_VSNPRINTF
! #  endif
! #endif
! #ifndef HAVE_VSNPRINTF
! #  ifdef MSDOS
!      /* vsnprintf may exist on some MS-DOS compilers (DJGPP?),
!         but for now we just assume it doesn't. */
! #    define NO_vsnprintf
! #  endif
! #  ifdef __TURBOC__
! #    define NO_vsnprintf
! #  endif
! #  ifdef WIN32
!      /* In Win32, vsnprintf is available as the "non-ANSI" _vsnprintf. */
! #    if !defined(vsnprintf) && !defined(NO_vsnprintf)
! #      define vsnprintf _vsnprintf
! #    endif
! #  endif
! #  ifdef __SASC
! #    define NO_vsnprintf
! #  endif
! #endif
! #ifdef VMS
! #  define NO_vsnprintf
  #endif
  
  #if defined(pyr)
***************
*** 207,214 ****
  #endif
  
  
- typedef uLong (ZEXPORT *check_func) OF((uLong check, const Bytef *buf,
- 				       uInt len));
  voidpf zcalloc OF((voidpf opaque, unsigned items, unsigned size));
  void   zcfree  OF((voidpf opaque, voidpf ptr));
  
--- 268,273 ----
***************
*** 217,220 ****
  #define ZFREE(strm, addr)  (*((strm)->zfree))((strm)->opaque, (voidpf)(addr))
  #define TRY_FREE(s, p) {if (p) ZFREE(s, p);}
  
! #endif /* _Z_UTIL_H */
--- 276,279 ----
  #define ZFREE(strm, addr)  (*((strm)->zfree))((strm)->opaque, (voidpf)(addr))
  #define TRY_FREE(s, p) {if (p) ZFREE(s, p);}
  
! #endif /* ZUTIL_H */
